<?php
// XI Core Ajax Helper Functions
//
// Copyright (c) 2008-2009 Nagios Enterprises, LLC.  All rights reserved.
//  
// $Id: ajaxhelpers-status.inc.php 26 2009-12-23 16:36:20Z egalstad $

include_once(dirname(__FILE__).'/../componenthelper.inc.php');
	
include_once(dirname(__FILE__).'/../nagioscore/coreuiproxy.inc.php');

////////////////////////////////////////////////////////////////////////
// GENERAL STATUS AJAX FUNCTIONS
// NOTE: HOST/SERVICE STATUS FUNCTIONS ARE ELSEWHERE
////////////////////////////////////////////////////////////////////////

function xicore_ajax_get_nagioscore_cgi_html($args=null){
	global $lstr;

	$output='';
	
	$url=$args["url"];
	//return 'hello there! URL='.$url;
	$output=coreuiproxy_get_embedded_cgi_output($url);
	
	return $output;
	}
	
function xicore_ajax_get_host_status_summary_html($args=null){
	global $lstr;
	
	//$timerinfo=array();

	$output='';
	
	$show=grab_array_var($args,"show","");
	$host=grab_array_var($args,"host","");
	$hostgroup=grab_array_var($args,"hostgroup","");
	$servicegroup=grab_array_var($args,"servicegroup","");
	$hostattr=grab_array_var($args,"hostattr",0);
	$serviceattr=grab_array_var($args,"serviceattr",0);
	$hoststatustypes=grab_array_var($args,"hoststatustypes",0);
	$servicestatustypes=grab_array_var($args,"servicestatustypes",0);

	// special "all" stuff
	if($hostgroup=="all")
		$hostgroup="";
	if($servicegroup=="all")
		$servicegroup="";
	if($host=="all")
		$host="";

	//  limit hosts by hostgroup or host
	$host_ids=array();
	$host_ids_str="";
	//  limit by hostgroup
	if($hostgroup!=""){
		$host_ids=get_hostgroup_member_ids($hostgroup);
		}
	//  limit by servicegroup hosts
	else if($servicegroup!=""){
		$host_ids=get_servicegroup_host_member_ids($servicegroup);
		}
	//  limit by host
	else if($host!=""){
		$host_ids[]=get_host_id($host);
		}
	$y=0;
	foreach($host_ids as $hid){
		if($y>0)
			$host_ids_str.=",";
		$host_ids_str.=$hid;
		$y++;
		}


	// PREP TO GET TOTAL RECORD COUNTS FROM BACKEND...
	$backendargs=array();
	$backendargs["cmd"]="gethoststatus";
	$backendargs["limitrecords"]=false;  // don't limit records
	$backendargs["totals"]=1; // only get recordcount
	// host id limiters
	if($host_ids_str!="")
		$backendargs["host_id"]="in:".$host_ids_str;

		
	// get total hosts
	//$timerinfo[]=get_timer();
	//$xml=get_backend_xml_data($backendargs);
	$xml=get_xml_host_status($backendargs);
	$total_records=0;
	if($xml)
		$total_records=intval($xml->recordcount);

	// get host totals (up/pending checked later)
	$state_totals=array();
	for($x=1;$x<=2;$x++){
		$backendargs["current_state"]=$x;
		//$timerinfo[]=get_timer();
		//$xml=get_backend_xml_data($backendargs);
		$xml=get_xml_host_status($backendargs);
		$state_totals[$x]=0;
		if($xml)
			$state_totals[$x]=intval($xml->recordcount);
		}
	// get up (non-pending)
	$backendargs["current_state"]=0;
	$backendargs["has_been_checked"]=1;
	//$timerinfo[]=get_timer();
	//$xml=get_backend_xml_data($backendargs);
	$xml=get_xml_host_status($backendargs);
	$state_totals[0]=0;
	if($xml)
		$state_totals[0]=intval($xml->recordcount);
	// get pending
	$backendargs["current_state"]=0;
	$backendargs["has_been_checked"]=0;
	//$timerinfo[]=get_timer();
	//$xml=get_backend_xml_data($backendargs);
	$xml=get_xml_host_status($backendargs);
	$state_totals[3]=0;
	if($xml)
		$state_totals[3]=intval($xml->recordcount);
	
	// total problems
	$total_problems=$state_totals[1]+$state_totals[2];
	
	// unhandled problems
	$backendargs["current_state"]="in:1,2";
	unset($backendargs["has_been_checked"]);
	//$backendargs["has_been_checked"]=1;
	$backendargs["problem_acknowledged"]=0;
	$backendargs["scheduled_downtime_depth"]=0;
	//$backendargs["notifications_enabled"]=1;
	//$timerinfo[]=get_timer();
	//$xml=get_backend_xml_data($backendargs);
	$xml=get_xml_host_status($backendargs);
	$unhandled_problems=0;
	if($xml)
		$unhandled_problems=intval($xml->recordcount);


	//$output.='ARGS: '.serialize($args);
	//$timerinfo[]=get_timer();
	/*
	$last_ti=0;
	$x=0;
	foreach($timerinfo as $ti){
		if($x==0){
			$last_ti=$ti;
			$x++;
			continue;
			}
		echo "T".$x."-T".($x-1).": ".get_timer_diff($last_ti,$ti)."<BR>";
		$last_ti=$ti;
		$x++;
		}
	//print_r($timerinfo);
	*/
		
		
	$output.='<div class="infotable_title">Host Status Summary</div>';
	
	if($show=="hostproblems" || $show=="hosts")
		$show="hosts";
	else
		$show="services";
	
	// urls
	$baseurl=get_base_url()."includes/components/xicore/status.php?";
	if($hostgroup!="")
		$baseurl.="&hostgroup=".$hostgroup;
	if($servicegroup!="")
		$baseurl.="&servicegroup=".$servicegroup;
	if($host!="")
		$baseurl.="&host=".$host;
	$state_text=array();
	
	$state_text[0]="<div class='hostup";
	if($state_totals[0]>0)
		$state_text[0].=" havehostup";
	$state_text[0].="'>";
	$state_text[0].="<a href='".$baseurl."&show=".$show."&hoststatustypes=".HOSTSTATE_UP."&servicestatustypes=".$servicestatustypes."'>".$state_totals[0]."</a>";
	$state_text[0].="</div>";

	$state_text[1]="<div class='hostdown";
	if($state_totals[1]>0)
		$state_text[1].=" havehostdown";
	$state_text[1].="'>";
	$state_text[1].="<a href='".$baseurl."&show=".$show."&hoststatustypes=".HOSTSTATE_DOWN."&servicestatustypes=".$servicestatustypes."'>".$state_totals[1]."</a>";
	$state_text[1].="</div>";

	$state_text[2]="<div class='hostunreachable";
	if($state_totals[2]>0)
		$state_text[2].=" havehostunreachable";
	$state_text[2].="'>";
	$state_text[2].="<a href='".$baseurl."&show=".$show."&hoststatustypes=".HOSTSTATE_UNREACHABLE."&servicestatustypes=".$servicestatustypes."'>".$state_totals[2]."</a>";
	$state_text[2].="</div>";

	$state_text[3]="<div class='hostpending";
	if($state_totals[3]>0)
		$state_text[3].=" havehostpending";
	$state_text[3].="'>";
	$state_text[3].="<a href='".$baseurl."&show=".$show."&hoststatustypes=".HOSTSTATE_PENDING."&servicestatustypes=".$servicestatustypes."'>".$state_totals[3]."</a>";
	$state_text[3].="</div>";
	
	$unhandled_problems_text="<div class='unhandledhostproblems";
	if($unhandled_problems>0)
		$unhandled_problems_text.=" haveunhandledhostproblems";
	$unhandled_problems_text.="'>";
	$unhandled_problems_text.="<a href='".$baseurl."&show=".$show."&servicestatustypes=".$servicestatustypes."&hoststatustypes=".(HOSTSTATE_DOWN|HOSTSTATE_UNREACHABLE)."&hostattr=".(HOSTSTATUSATTR_NOTACKNOWLEDGED|HOSTSTATUSATTR_NOTINDOWNTIME)."'>".$unhandled_problems."</a>";
	$unhandled_problems_text.="</div>";
	
	$total_problems_text="<div class='hostproblems";
	if($total_problems>0)
		$total_problems_text.=" havehostproblems";
	$total_problems_text.="'>";
	$total_problems_text.="<a href='".$baseurl."&show=".$show."&hoststatustypes=".(HOSTSTATE_DOWN|HOSTSTATE_UNREACHABLE)."&servicestatustypes=".$servicestatustypes."'>".$total_problems."</a>";
	$total_problems_text.="</div>";
	
	$total_records_text="<div class='allhosts";
	if($total_records>0)
		$total_records_text.=" haveallhosts";
	$total_records_text.="'>";
	$total_records_text.="<a href='".$baseurl."&show=".$show."&servicestatustypes=".$servicestatustypes."'>".$total_records."</a>";
	$total_records_text.="</div>";

	if(1){
		$output.='
		<table class="infotable">
		<thead>
		<tr><th>'.$lstr['HostStateUpText'].'</th><th>'.$lstr['HostStateDownText'].'</th><th>'.$lstr['HostStateUnreachableText'].'</th><th>'.$lstr['HostStatePendingText'].'</th></tr>
		</thead>
		';
		$output.='
		<tbody>
		<tr><td>'.$state_text[0].'</td><td>'.$state_text[1].'</td><td>'.$state_text[2].'</td><td>'.$state_text[3].'</td></tr>
		</tbody>
		';
		$output.='
		<thead>
		<tr><th colspan="2">Unhandled</th><th>Problems</th><th>All</th></tr>
		</thead>
		';
		$output.='
		<tbody>
		<tr><td colspan="2">'.$unhandled_problems_text.'</td><td>'.$total_problems_text.'</td><td>'.$total_records_text.'</td></tr>
		</tbody>
		';
		$output.='
		</table>';
		}

	$output.='
	<div class="ajax_date">Last Updated: '.get_datetime_string(time()).'</div>
	';
	
	return $output;
	}

function xicore_ajax_get_service_status_summary_html($args=null){
	global $lstr;

	//$timerinfo=array();

	$output='';
	
	$host=grab_array_var($args,"host","");
	$hostgroup=grab_array_var($args,"hostgroup","");
	$servicegroup=grab_array_var($args,"servicegroup","");
	$hostattr=grab_array_var($args,"hostattr",0);
	$serviceattr=grab_array_var($args,"serviceattr",0);
	$hoststatustypes=grab_array_var($args,"hoststatustypes",HOSTSTATE_ANY);
	$servicestatustypes=grab_array_var($args,"servicestatustypes",SERVICESTATE_ANY);
	
	// special "all" stuff
	if($hostgroup=="all")
		$hostgroup="";
	if($servicegroup=="all")
		$servicegroup="";
	if($host=="all")
		$host="";

	//  limit hosts by hostgroup or host
	$host_ids=array();
	$host_ids_str="";
	//  limit by hostgroup
	if($hostgroup!=""){
		$host_ids=get_hostgroup_member_ids($hostgroup);
		}
	//  limit by host
	else if($host!=""){
		$host_ids[]=get_host_id($host);
		}
	$y=0;
	foreach($host_ids as $hid){
		if($y>0)
			$host_ids_str.=",";
		$host_ids_str.=$hid;
		$y++;
		}
	//  limit service by servicegroup
	$service_ids=array();
	$service_ids_str="";
	if($servicegroup!=""){
		$service_ids=get_servicegroup_member_ids($servicegroup);
		}
	$y=0;
	foreach($service_ids as $sid){
		if($y>0)
			$service_ids_str.=",";
		$service_ids_str.=$sid;
		$y++;
		}


	// PREP TO GET TOTAL RECORD COUNTS FROM BACKEND...
	$backendargs=array();
	$backendargs["cmd"]="getservicestatus";
	$backendargs["limitrecords"]=false;  // don't limit records
	$backendargs["totals"]=1; // only get recordcount
	$backendargs["combinedhost"]=true;  // get host status too
	// host id limiters
	if($host_ids_str!="")
		$backendargs["host_id"]="in:".$host_ids_str;
	// service id limiters
	if($service_ids_str!="")
		$backendargs["service_id"]="in:".$service_ids_str;

		
	// get total services
	//$timerinfo[]=get_timer();
	//$xml=get_backend_xml_data($backendargs);
	$xml=get_xml_service_status($backendargs);
	$total_records=0;
	if($xml)
		$total_records=intval($xml->recordcount);

	// get state totals (ok/pending checked later)
	$state_totals=array();
	for($x=1;$x<=3;$x++){
		$backendargs["current_state"]=$x;
		//$timerinfo[]=get_timer();
		//$xml=get_backend_xml_data($backendargs);
		$xml=get_xml_service_status($backendargs);
		$state_totals[$x]=0;
		if($xml)
			$state_totals[$x]=intval($xml->recordcount);
		}
	// get ok (non-pending)
	$backendargs["current_state"]=0;
	$backendargs["has_been_checked"]=1;
	//$timerinfo[]=get_timer();
	//$xml=get_backend_xml_data($backendargs);
	$xml=get_xml_service_status($backendargs);
	$state_totals[0]=0;
	if($xml)
		$state_totals[0]=intval($xml->recordcount);
	// get pending
	$backendargs["current_state"]=0;
	$backendargs["has_been_checked"]=0;
	//$timerinfo[]=get_timer();
	//$xml=get_backend_xml_data($backendargs);
	$xml=get_xml_service_status($backendargs);
	$state_totals[4]=0;
	if($xml)
		$state_totals[4]=intval($xml->recordcount);
	
	// total problems
	$total_problems=$state_totals[1]+$state_totals[2]+$state_totals[3];
	
	// unhandled problems
	$backendargs["current_state"]="in:1,2,3";
	unset($backendargs["has_been_checked"]);
	//$backendargs["has_been_checked"]=1;
	$backendargs["problem_acknowledged"]=0;
	$backendargs["scheduled_downtime_depth"]=0;
	//$backendargs["notifications_enabled"]=1;
	$backendargs["host_current_state"]=0; // up state
	//$timerinfo[]=get_timer();
	//$xml=get_backend_xml_data($backendargs);
	$xml=get_xml_service_status($backendargs);
	$unhandled_problems=0;
	if($xml)
		$unhandled_problems=intval($xml->recordcount);


	//$output.='ARGS: '.serialize($args);
	//$timerinfo[]=get_timer();
	/*
	$last_ti=0;
	$x=0;
	foreach($timerinfo as $ti){
		if($x==0){
			$last_ti=$ti;
			$x++;
			continue;
			}
		echo "T".$x."-T".($x-1).": ".get_timer_diff($last_ti,$ti)."<BR>";
		$last_ti=$ti;
		$x++;
		}
	//print_r($timerinfo);
	*/

	$output.='<div class="infotable_title">Service Status Summary</div>';
	
	$show="services";

	// urls
	$baseurl=get_base_url()."includes/components/xicore/status.php?";
	if($hostgroup!="")
		$baseurl.="&hostgroup=".$hostgroup;
	if($servicegroup!="")
		$baseurl.="&servicegroup=".$servicegroup;
	if($host!="")
		$baseurl.="&host=".$host;
	$state_text=array();
	
	
	$state_text[0]="<div class='serviceok";
	if($state_totals[0]>0)
		$state_text[0].=" haveserviceok";
	$state_text[0].="'>";
	$state_text[0].="<a href='".$baseurl."&show=".$show."&hoststatustypes=".$hoststatustypes."&servicestatustypes=".SERVICESTATE_OK."'>".$state_totals[0]."</a>";
	$state_text[0].="</div>";

	$state_text[1]="<div class='servicewarning";
	if($state_totals[1]>0)
		$state_text[1].=" haveservicewarning";
	$state_text[1].="'>";
	$state_text[1].="<a href='".$baseurl."&show=".$show."&hoststatustypes=".$hoststatustypes."&servicestatustypes=".SERVICESTATE_WARNING."'>".$state_totals[1]."</a>";
	$state_text[1].="</div>";

	$state_text[3]="<div class='serviceunknown";
	if($state_totals[3]>0)
		$state_text[3].=" haveserviceunknown";
	$state_text[3].="'>";
	$state_text[3].="<a href='".$baseurl."&show=".$show."&hoststatustypes=".$hoststatustypes."&servicestatustypes=".SERVICESTATE_UNKNOWN."'>".$state_totals[3]."</a>";
	$state_text[3].="</div>";

	$state_text[2]="<div class='servicecritical";
	if($state_totals[2]>0)
		$state_text[2].=" haveservicecritical";
	$state_text[2].="'>";
	$state_text[2].="<a href='".$baseurl."&show=".$show."&hoststatustypes=".$hoststatustypes."&servicestatustypes=".SERVICESTATE_CRITICAL."'>".$state_totals[2]."</a>";
	$state_text[2].="</div>";

	$state_text[4]="<div class='unhandledserviceproblems";
	if($state_totals[4]>0)
		$state_text[4].=" haveunhandledserviceproblems";
	$state_text[4].="'>";
	$state_text[4].="<a href='".$baseurl."&show=".$show."&hoststatustypes=".$hoststatustypes."&servicestatustypes=".SERVICESTATE_PENDING."'>".$state_totals[4]."</a>";
	$state_text[4].="</div>";
	
	$unhandled_problems_text="<div class='unhandledserviceproblems";
	if($unhandled_problems>0)
		$unhandled_problems_text.=" haveunhandledserviceproblems";
	$unhandled_problems_text.="'>";
	$unhandled_problems_text.="<a href='".$baseurl."&show=".$show."&hoststatustypes=".$hoststatustypes."&servicestatustypes=".(SERVICESTATE_WARNING|SERVICESTATE_UNKNOWN|SERVICESTATE_CRITICAL)."&serviceattr=".(SERVICESTATUSATTR_NOTACKNOWLEDGED|SERVICESTATUSATTR_NOTINDOWNTIME)."'>".$unhandled_problems."</a>";
	$unhandled_problems_text.="</div>";
	
	$total_problems_text="<div class='serviceproblems";
	if($total_problems>0)
		$total_problems_text.=" haveserviceproblems";
	$total_problems_text.="'>";
	$total_problems_text.="<a href='".$baseurl."&show=".$show."&hoststatustypes=".$hoststatustypes."&servicestatustypes=".(SERVICESTATE_WARNING|SERVICESTATE_UNKNOWN|SERVICESTATE_CRITICAL)."'>".$total_problems."</a>";
	$total_problems_text.="</div>";
	
	$total_records_text="<div class='allservices";
	if($total_records>0)
		$total_records_text.=" haveallservices";
	$total_records_text.="'>";
	$total_records_text.="<a href='".$baseurl."&show=".$show."&hoststatustypes=".$hoststatustypes."'>".$total_records."</a>";
	$total_records_text.="</div>";
		

	if(1){
		$output.='
		<table class="infotable">
		<thead>
		<tr><th>'.$lstr['ServiceStateOkText'].'</th><th>'.$lstr['ServiceStateWarningText'].'</th><th>'.$lstr['ServiceStateUnknownText'].'</th><th>'.$lstr['ServiceStateCriticalText'].'</th><th>'.$lstr['ServiceStatePendingText'].'</th></tr>
		</thead>
		';
		$output.='
		<tbody>
		<tr><td>'.$state_text[0].'</td><td>'.$state_text[1].'</td><td>'.$state_text[3].'</td><td>'.$state_text[2].'</td><td>'.$state_text[4].'</td></tr>
		</tbody>
		';
		$output.='
		<thead>
		<tr><th colspan="2">Unhandled</th><th colspan="2">Problems</th><th>All</th></tr>
		</thead>
		';
		$output.='
		<tbody>
		<tr><td colspan="2">'.$unhandled_problems_text.'</td><td colspan="2">'.$total_problems_text.'</td><td>'.$total_records_text.'</td></tr>
		</tbody>
		';
		$output.='
		</table>';
		}
		
	$output.='
	<div class="ajax_date">Last Updated: '.get_datetime_string(time()).'</div>
	';
	
	return $output;
	}

	
	
?>